<script setup lang="ts">
import { ref, reactive, computed } from 'vue';

import type { BaseImage, BaseLink, BaseQuoteCard } from '@/types/base';

type AccordionItem = {
  header: string;
  text: string;
  primaryCtas?: Array<BaseLink>;
  secondaryCtaHeader?: string;
  secondaryCtas?: Array<BaseLink>;
};

export type Tab = {
  tabButtonText: string;
  config: {
    dataGaName: string;
    dataGaLocation: string;
  };
  tabPanelContent: {
    accordion: Array<AccordionItem>;
  };
  caseStudy?: Array<BaseQuoteCard>;
  featuredCta?: {
    config: {
      href: string;
      dataGaName: string;
      dataGaLocation: string;
    };
    boxText: {
      title: string;
      highlight?: string;
      text: string;
    };
  };
};

const props = defineProps({
  tabs: {
    type: Object as Array<Tab>,
    required: true,
  },
  header: {
    type: Object,
    required: true,
  },
  image: {
    type: Object as BaseImage,
    required: true,
  },
});

const videoUrl = ref('');
const selectedTab = ref(0);
const isOpenIndex = ref<number | null>(0);
const modal = reactive({ open: false });

const tabs = computed(() => props.tabs || []);
const videos = computed(() =>
  tabs.value.flatMap((tab: Tab) =>
    tab.tabPanelContent.accordion.flatMap((accordionItem: AccordionItem) =>
      accordionItem.secondaryCtas
        ?.map((cta: BaseLink) => (cta.config.modal ? cta.config.href : null))
        .filter((url: string | null) => url !== null),
    ),
  ),
);

const isVideoModalVisible = (video: string): boolean => {
  return modal.open && videoUrl.value === video;
};

const onTabChange = (value: number) => {
  selectedTab.value = value;
  isOpenIndex.value = 0;
};

const toggleController = (index: number) => {
  isOpenIndex.value = isOpenIndex.value === index ? null : index;
};

const closeModal = () => {
  modal.open = false;
  videoUrl.value = '';
};

const openVideoModal = (video: string) => {
  videoUrl.value = video;
  modal.open = true;
};
</script>

<template>
  <section class="platform-tabs">
    <SlpContainer>
      <h2 class="slp-mb-8">
        <SlpTypography tag="div" variant="heading1-bold" class="gradient-header slp-mb-8">
          {{ props.header.highlighted }}
        </SlpTypography>

        <SlpTypography tag="div" variant="heading4-bold">
          {{ props.header.text }}
        </SlpTypography>
      </h2>
      <SlpRow class="platform-tabs__row">
        <SlpColumn :col="6" class="slp-pl-md-16">
          <div class="platform-tabs__wrapper">
            <div class="platform-tabs__tabs" role="tablist" aria-labelledby="tablist-1">
              <button
                v-for="(tab, tabIndex) in props.tabs"
                :id="`tab-${tab.config.dataGaName}`"
                :key="tab.tabButtonText"
                ref="tab"
                type="button"
                role="tab"
                aria-selected="true"
                :aria-controls="`tabpanel-${tab.config.dataGaName}`"
                class="platform-tabs__tab"
                :class="selectedTab == tabIndex ? 'platform-tabs__tab--active' : ''"
                :data-ga-name="tab.config.dataGaName"
                :data-ga-location="tab.config.dataGaLocation"
                @click="onTabChange(tabIndex)"
              >
                <SlpTypography variant="heading5-bold" tag="span">
                  <span class="">{{ tab.tabButtonText }} </span>
                </SlpTypography>
              </button>
            </div>
          </div>
          <div
            v-for="(tabContent, tabContentIndex) in props.tabs"
            v-show="tabContentIndex === selectedTab"
            :id="`tabpanel-${tabContent.config.dataGaName}`"
            :key="`tab-content-${tabContent.config.dataGaName}`"
            role="tabpanel"
            tabindex="0"
            :aria-labelledby="`tab-${tabContent.config.dataGaName}`"
            class="platform-tabs__content"
            :class="{ 'platform-tabs__content--active': selectedTab === tabContentIndex }"
          >
            <CommonAccordion
              v-for="(item, index) in tabContent.tabPanelContent.accordion"
              :key="item.header"
              :data="item"
              :is-open="isOpenIndex == index"
              @toggle-controller="toggleController(index)"
            >
              <template #content>
                <div v-if="typeof item.content === 'string'" v-html="$md.render(item.content)"></div>
                <PlatformAccordionList
                  :data="item.primaryCtas"
                  @on-open-video-modal="openVideoModal"
                  @on-close-modal="closeModal"
                />
                <SlpTypography variant="body1-bold" tag="p" class="slp-my-16">
                  {{ item.secondaryCtaHeader }}
                </SlpTypography>

                <PlatformAccordionList
                  :data="item.secondaryCtas"
                  @on-open-video-modal="openVideoModal"
                  @on-close-modal="closeModal"
                />
              </template>
            </CommonAccordion>
          </div>
          <PlatformFeaturedCta :data="props.tabs[selectedTab].featuredCta" :is-first-entry="selectedTab === 0" />
        </SlpColumn>
        <SlpColumn :col="6" class="slp-pr-md-16">
          <div v-if="props?.image?.config.src" class="platform-tabs__container">
            <img
              v-if="props.image"
              class="platform-tabs__image"
              :src="props.image.config.src"
              :alt="props.image.alt"
              aria-hidden="true"
              data-aos="fade-left"
              data-aos-duration="2000"
              loading="lazy"
            />
          </div>
        </SlpColumn>
      </SlpRow>
      <CommonQuoteCarousel v-bind="props.tabs[selectedTab].caseStudy" dark-mode />
    </SlpContainer>
  </section>
  <div v-for="video in videos" :key="video">
    <CommonVideoModal light-background :visible="isVideoModalVisible(video)" @close="closeModal">
      <template #body>
        <CommonVideo :video-src="video" />
      </template>
    </CommonVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.platform-tabs {
  background: $color-surface-700;
  color: $color-surface-50;
  padding: $spacing-64 0 $spacing-32 0;

  @media (min-width: $breakpoint-sm) {
    padding: $spacing-48 0 $spacing-64 0;
  }

  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0 $spacing-64 0;
  }

  &:deep(.slp-col-md-6) {
    width: 100%;
  }

  &__header {
    max-width: 480px;
    background: linear-gradient(91.08deg, #feb484 1.97%, #a686f2 27.88%, #592ac8 65.98%);
    background-clip: text;
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
  }

  &__tabs {
    display: flex;
    flex-wrap: wrap;
    padding: $spacing-32 0 0 0;

    @media (min-width: $breakpoint-md) {
      display: block;
    }
  }

  &__tab {
    background: $color-surface-600;
    border-radius: 90px;
    border: none;
    color: $color-surface-50;
    margin-right: $spacing-8;
    padding: $spacing-8 $spacing-24;
    margin-bottom: $spacing-16;
    transition: all 0.3s ease;
    cursor: pointer;
    flex: 0 0 auto;

    @media (min-width: $breakpoint-md) {
      margin-right: $spacing-24;
    }

    &:hover,
    &:focus,
    &:active,
    &--active {
      background: $color-accent-500;
    }
  }

  &__feature-header {
    display: block;
    color: $color-accent-400;

    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  &__content {
    opacity: 0;

    img {
      width: 100%;
    }

    &--active {
      animation: fade-in 0.3s linear forwards 0.1s;
    }

    &:deep(.accordion__summary) {
      font-weight: $font-weight-bold;
      padding: 14px 0;
    }

    &:deep(.accordion__content-container p) {
      font-size: 16px;
      line-height: 24px;
      margin-bottom: 16px;
    }
  }

  &__feature {
    color: $color-surface-50;
    display: flex;
    align-items: center;
    margin-bottom: $spacing-32;

    &__button {
      color: $color-surface-50;
      display: inline-block;
      text-align: left;

      :deep(.slp-icon) {
        display: inline-flex;
        align-items: center;
        margin-left: 3px;
        width: 16px;
        height: 16px;
        position: relative;
        top: 2px;

        div {
          position: absolute;
          display: inline-flex;
          align-items: center;
          margin-bottom: -2px;
        }
      }
    }
  }

  &__button-icon {
    color: $color-accent-400;
  }

  &__icon-stroke {
    stroke: currentColor;

    :deep(path) {
      stroke: currentColor;
    }
  }

  &__blurb {
    max-width: 800px;
  }

  &__row {
    @media (min-width: $breakpoint-md) {
      margin-left: -16px;
    }

    @media (max-width: $breakpoint-md) {
      flex-direction: column-reverse;
    }
  }

  &__col {
    padding-left: 32px;

    &--media {
      :deep(.container) {
        margin-bottom: 0;
      }
    }
  }

  @keyframes fade-in {
    from {
      opacity: 0;
      transform: translateY(10px);
    }

    to {
      opacity: 1;
      transform: translateY(0);
    }
  }

  &__img-container {
    line-height: 0;
  }
}

// Navattic iframe styling
.demo-modal {
  position: relative;

  .demo-thumbnail {
    max-width: 100%;
    display: block;
    height: auto;
    filter: blur(1px);
    z-index: 1;
    transition: filter 0.3s ease-in-out;
  }

  .demo-button {
    position: absolute;
    top: 40%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: 2;
    border-radius: 30px;
    width: 228px;
    display: flex;
    justify-content: center;

    &:hover {
      box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);
    }

    .slp-icon {
      margin-right: 5px;
      width: 24px;
      height: 24px;
    }
  }
}

.platform-tabs:deep(.accordion) {
  color: #fff;
  margin: 48px 0 32px 0;

  .accordion__header {
    color: #fff;
  }

  .accordion__icon {
    color: #fff;

    &:before,
    &::after {
      background-color: currentColor;
    }
  }

  .summary {
    border: none;
    padding: 14px 0;
  }

  .content-container {
    padding-bottom: 0;
  }
}

.gradient-header {
  display: inline-block;
  background: linear-gradient(123deg, #f9a026 0%, #a686f2 45.5%, #592ac8 100%);
  -webkit-background-clip: text;
  background-clip: text;
  -webkit-text-fill-color: transparent;
}

.platform-tabs__container {
  position: relative;
  text-align: center;

  @media (max-width: $breakpoint-lg) {
    margin-bottom: $spacing-48;
  }

  .platform-tabs__image {
    max-width: 450px;
    width: 100%;
    max-height: 800px;
    margin-top: 0;

    @media (max-width: $breakpoint-lg) {
      margin-top: 48px;
    }
  }
}
</style>
